import { Subject } from "../Subject";
import { ObjectLiteral } from "../../common/ObjectLiteral";
/**
 * Finds all cascade operations of the given subject and cascade operations of the found cascaded subjects,
 * e.g. builds a cascade tree and creates a subjects for them.
 */
export declare class CascadesSubjectBuilder {
    protected subject: Subject;
    constructor(subject: Subject);
    /**
     * Builds a cascade subjects tree and pushes them in into the given array of subjects.
     */
    build(): Subject[];
    /**
     * Builds a cascade subjects recursively.
     */
    protected buildRecursively(subjects: Subject[], subject: Subject): void;
    /**
     * Finds subject where entity like given subject's entity.
     * Comparision made by entity id.
     */
    protected findByPersistEntityLike(subjects: Subject[], entityTarget: Function | string, entity: ObjectLiteral): Subject | undefined;
}
